Subject: bug#20628: 25.0.50; Incorrect line height for some fonts

From: Clément Pit--Claudel <[email-masked]>
Date: Fri, 22 May 2015 19:55:24 -0400

On 05/22/2015 06:43 PM, Stefan Monnier wrote:
>> The reason gedit was working fine previously is that it never used
>> "Latin Modern Math", it used some other font.
> 
> IOW Emacs doesn't seem to behave differently from other applications
> w.r.t this font, except for the fact that it ends up selecting up while
> other apps select another font instead.

No, I don't think that's correct. On my machine, explicitly selecting Latin Modern Math on Emacs yields very tall lines. Selecting it in gedit or LibreOffice or Tomboy (the notes application) does not. See the attached screenshots.

> So the question becomes: why does Emacs select this font and how could
> we change ti so it selects something else.

If we don't have a way to detect misbehaving fonts dynamically, then I don't think that this works. Indeed, Latin Modern Math is not the only misbehaving font.

> BTW, I think that using something like
> 
>     (set-fontset-font fontset 'unicode (font-spec :name "Symbola") nil 'append)
> or
>     (set-fontset-font "fontset-default" '(#x1d400 . #x1d7ff) "Symbola")
> 
> just sucks: we don't want to say "use Symbola", but we instead want to
> say something like "avoid Latin Modern Math" or "ignore Latin Modern
> Math's ascent/descent information".

I don't think so; this forces us to maintain a list of misbehaving fonts. If we just say "Avoid Latin Modern Math" and the next selected font is also broken, then the problem remains (Asana Math, for example, is broken too, albeit a bit less). Ideally, we would also want to be able to use Latin Modern Math: ignoring the height issue, it's a nice font for maths symbols.

Clément.